/* -*- Mode: C; c-file-style: "bsd" -*- */

/* From main.c of numexp-0.4, http://numexp.sourceforge.net/ */

//#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

//#include <string.h>
//#include <glade/glade.h>
//#include <signal.h>
//#include <pthread.h>

//#include <gconf/gconf-client.h>

void        splash_screen             (const char* img);

gint splash_screen_cb(gpointer data)
{
    gdk_threads_enter();
    gtk_widget_hide(GTK_WIDGET(data));
    gtk_object_destroy(GTK_OBJECT(data));
    gdk_threads_leave();
    return FALSE;
}

void splash_screen(const char* img)
{
    GtkWidget *pixmap_wid, *window;
    GdkPixmap *pix;
    GdkBitmap *mask;
    gint w, h, W, H;

    gdk_threads_enter();
    window = gtk_window_new(GTK_WINDOW_POPUP);
    pixmap_wid = (GtkWidget *) widget_from_image_file(img); /* XXX: cast */
    gtk_container_add(GTK_CONTAINER(window), pixmap_wid);
    pix = GTK_PIXMAP(pixmap_wid)->pixmap;
    gdk_window_get_size(pix, &w, &h);
    W = gdk_screen_width();
    H = gdk_screen_height();
    gtk_widget_set_uposition(window, W / 2 - w / 2, H / 2 - h / 2);
    mask = GTK_PIXMAP(pixmap_wid)->mask;
    gtk_widget_shape_combine_mask(window, mask, 0, 0);
    gtk_widget_show_all(window);
    while (gtk_events_pending() || !GTK_WIDGET_REALIZED(pixmap_wid))
	gtk_main_iteration();
    gtk_timeout_add( 3e3, splash_screen_cb, window );
    gdk_threads_leave();
}

main()
{
splash_screen("splash.xpm");
}

